//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"

bool gbCanMove=false;
POINT gptCursor;
POINT gptControl;
TControl *gCtrl;

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   Application->OnMessage=AppMessage;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AppMessage(tagMSG &Msg, bool &Handled)
{
   if(Msg.message==WM_MOUSEMOVE && gbCanMove && gCtrl)
   {
      POINT ptCursor;
      GetCursorPos(&ptCursor);
      int iXOffset=ptCursor.x-gptCursor.x;
      int iYOffset=ptCursor.y-gptCursor.y;
      int iLeft=gptControl.x+iXOffset;
      int iTop=gptControl.y+iYOffset;
      if(iLeft>0 && iLeft+gCtrl->Width<=Panel1->Width)
      {
         gCtrl->Left=iLeft;
      }
      if(iTop>=0 && iTop+gCtrl->Height<=Panel1->Height)
      {
         gCtrl->Top=iTop;
      }
   }
   if(Msg.message==WM_LBUTTONDOWN)
   {
      gbCanMove=true;
      GetCursorPos(&gptCursor);
      TPoint ptCursor=Panel1->ScreenToClient(gptCursor);
      TControl *Ctrl=Panel1->ControlAtPos(ptCursor, true, true);
      if(Ctrl)
      {
         gptControl.x=Ctrl->Left;
         gptControl.y=Ctrl->Top;
         gCtrl=Ctrl;
      }
   }
   if(Msg.message==WM_LBUTTONUP)
   {
      gbCanMove=false;
      gCtrl=NULL;
   }
}
//---------------------------------------------------------------------------
